#include <iostream>
#include <windows.h>
#include "WindowsConsole.h"
#include "NPC.h"

NPC::NPC(bool can_move, int forwardSpeed, char character)
{
    this->canMove = can_move;
    this->speedDelay = (120-forwardSpeed);
    this->character = character;

}
NPC::~NPC(){
    using namespace std;
    WindowsConsole console(false);
    console.GotoXY(this->pos[0],this->pos[1]);
    cout << " ";
    this->destroy=true;
}
void NPC::send(int roadX, int roadWeight, int roadWidth){
    this->issend = true;
    this->pos[0] = roadX + roadWeight + rand()%roadWidth;
    this->draw();
}
void NPC::update(int roadPositions[], int roadWidth[]){
    if (this->issend && !this->destroy){
        if (!this->moveCounter){
            this->direction = 0;
            if (this->canMove)
                this->direction = rand()%3-1;
            this->moveCounter = rand()%roadWidth[0]+1;
            this->pos[0] += this->direction;
        } else{
            this->pos[0] += this->direction;
            this->moveCounter--;
        }

        if (this->pos[0] <= roadPositions[this->pos[1]])
            this->direction=1;
        else if (this->pos[0] >= roadPositions[this->pos[1]]+roadWidth[this->pos[1]])
            this->direction=-1;
        if (this->pos[1] == 23){
            delete this;
        }
        else {
            this->pos[1]++;
            this->draw();
        }
    }
}
void NPC::draw(){
    using namespace std;
    WindowsConsole console(false);
    console.GotoXY(0,0);
    if (this->pos[1]>0){
        console.GotoXY(this->pos[0]-1,this->pos[1]-1);
        cout << "   ";
    }
    console.GotoXY(this->pos[0],this->pos[1]);
    cout << this->character;
}
