#include <iostream>
#include <stdlib.h>
#include <windows.h>
#include "WindowsConsole.h"
#include "weg.h"
weg::weg(int weight,int width,int startX,char roadChar)
{
    this->weight = weight;
    for (int i=0;i<=24;i++)
        this->width[i] = width;
    this->character = roadChar;
    this->turn = rand()%3-1;
    this->turncount = rand()%8+3;
    for (int i = 0;i<24;i++)
    {
        if (i > 12)
            this->positions[i] = startX;
        else
            this->positions[i] = startX+1;
    }
}
void weg::update(){
    for (int i = 23;i>=0;i--)
    {
        if (i == 0){
            if (this->turncount<=0){
                this->turn = rand()%3-1;
                this->turncount = rand()%15+1;
            }
            if (this->positions[0] <= 1)
                this->turn = 1;
            if (this->positions[0]+this->width[0] >= (79-this->weight))
                this->turn = -1;
            if (this->width[0] != this->width[4])
                this->turn = 0;
            this->positions[i] += this->turn;
            this->turncount--;
        } else{
            this->positions[i] = this->positions[i-1];
            this->width[i] = this->width[i-1];
        }
    }
}
void weg::draw()
{
    using namespace std;
    WindowsConsole console(false);
    for (int i = 23;i>=0;i--)
    {
        if (i < 23){
            console.GotoXY(this->positions[i+1],i);
            for (int i = 0;i<this->weight;i++)
                cout << "  ";

            console.GotoXY(this->positions[i+1]+this->width[i+1],i);
            for (int i = 0;i<this->weight;i++)
                cout << "  ";
        } else {
            console.GotoXY(this->positions[i]-1,i);
            cout << "  ";
            console.GotoXY(this->positions[i]+this->weight+1,i);
            cout << "  ";
            console.GotoXY(this->positions[i]+this->width[i]-1,i);
            cout << "  ";
            console.GotoXY(this->positions[i]+this->width[i]+this->weight+1,i);
            cout << "  ";
            console.GotoXY(this->positions[i],i);
            cout << "  ";
            console.GotoXY(this->positions[i]+this->weight,i);
            cout << "  ";
            console.GotoXY(this->positions[i]+this->width[i],i);
            cout << "  ";
            console.GotoXY(this->positions[i]+this->width[i]+this->weight,i);
            cout << "  ";
        }
        console.GotoXY(this->positions[i],i);
        for (int i = 0;i<this->weight;i++)
            cout << this->character;

        console.GotoXY(this->positions[i]+this->width[i],i);
        for (int i = 0;i<this->weight;i++)
            cout << this->character;

    }
}
bool weg::hit(int pPosX, int pPosY, int pHeight, int pWidth){
    int i = pPosY;
    do {
        if (this->positions[i]+this->weight > pPosX)
            return true;
        if (this->positions[i]+this->width[i] < pPosX+pWidth)
            return true;
        i++;
    } while (i<pPosY+pHeight);
    return false;
}
